package com.consultingwerk.plugins.smartunitlaunchconfig.delegates;

import java.io.IOException;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.debug.core.ILaunch;
import org.eclipse.debug.core.ILaunchConfiguration;
import org.eclipse.debug.core.model.LaunchConfigurationDelegate;

import com.consultingwerk.plugins.common.utilities.ConsoleHelper;
import com.consultingwerk.plugins.smartunitlaunchconfig.utilities.SmartUnitHelper;

/**
 * Delegate for launching SmartUnit tests
 */
public class SmartUnitDelegate 
    extends LaunchConfigurationDelegate 
{
    /**
     * Launches the given configuration
     * @param configuration the configuration to launch
     * @param mode The mode to launch (run, debug,..)
     * @param launch The launch object
     * @param monitor The ProgressMonitor to use
     */
    @Override
    public void launch (ILaunchConfiguration config, 
                        String mode, 
                        ILaunch launch, 
                        IProgressMonitor monitor)
    {
        try
        {
            if(monitor != null)
                monitor.beginTask("SmartUnit", 100);
            SmartUnitHelper.run (launch, mode, monitor);
            if(monitor != null)
                monitor.done();
        }
        catch (CoreException | IOException | InterruptedException e)
        {
            monitor.setCanceled(true);
            ConsoleHelper.printException (e);
        }
    }
}
